"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = RenderTree;

var _react = _interopRequireDefault(require("react"));

var _reactNative = require("react-native");

var _reactNativeRenderHtml = require("react-native-render-html");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const styles = _reactNative.StyleSheet.create({
  colContainer: {
    flexDirection: 'column',
    flexGrow: 1
  },
  rowContainer: {
    flexDirection: 'row',
    flexGrow: 1
  }
});

function RenderTree({
  node,
  config
}) {
  if (node.type === 'cell') {
    const {
      width
    } = node;
    const style = {
      width,
      flexGrow: 1
    };
    return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: style
    }, /*#__PURE__*/_react.default.createElement(_reactNativeRenderHtml.TNodeRenderer, {
      propsFromParent: {
        cell: node,
        collapsedMarginTop: null,
        config
      },
      parentMarkers: {},
      tnode: node.tnode
    }));
  }

  if (node.type === 'root' || node.type === 'col-container') {
    const children = node.children.map((v, i) => /*#__PURE__*/_react.default.createElement(RenderTree, {
      node: v,
      key: i,
      config
    }));
    return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.colContainer
    }, children);
  }

  if (node.type === 'row-container') {
    return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.rowContainer
    }, node.children.map((v, i) => /*#__PURE__*/_react.default.createElement(RenderTree, {
      node: v,
      key: i,
      config
    })));
  }

  return null;
}
//# sourceMappingURL=RenderTree.js.map